export type MessageBody = string | string[] | (string | string[])[];

export const LANGUAGE_DEFAULT_STATUS_MESSAGE_KEYS = [
	'unableToInitializeResourceDataSource',
	'unableToFetchResourceCollection',
	'unableToFetchResource',
	'resourceIdNotGiven',
	'languageNotAcceptable',
	'encodingNotAcceptable',
	'mediaTypeNotAcceptable',
	'methodNotAllowed',
	'urlNotFound',
	'badRequest',
	'ok',
	'resourceCollectionFetched',
	'resourceFetched',
	'resourceNotFound',
	'deleteNonExistingResource',
	'unableToCreateResource',
	'unableToGenerateIdFromResourceDataSource',
	'unableToEmplaceResource',
	'unableToSerializeResponse',
	'unableToEncodeResponse',
	'unableToDeleteResource',
	'resourceDeleted',
	'unableToDeserializeRequest',
	'patchNonExistingResource',
	'unableToPatchResource',
	'invalidResourcePatch',
	'invalidResource',
	'resourcePatched',
	'resourceCreated',
	'resourceReplaced',
] as const;

export type LanguageDefaultStatusMessageKey = typeof LANGUAGE_DEFAULT_STATUS_MESSAGE_KEYS[number];

export interface LanguageStatusMessageMap extends Record<LanguageDefaultStatusMessageKey, string> {}

export const LANGUAGE_DEFAULT_BODY_KEYS = [
	'languageNotAcceptable',
	'encodingNotAcceptable',
	'mediaTypeNotAcceptable',
] as const;

export type LanguageDefaultBodyKey = typeof LANGUAGE_DEFAULT_BODY_KEYS[number];

export interface LanguageBodyMap extends Record<LanguageDefaultBodyKey, MessageBody> {}

export interface Language {
	name: string,
	statusMessages: LanguageStatusMessageMap,
	bodies: LanguageBodyMap
}
